<template>
	<xn-form-container
		:title="formData.id ? '编辑客户' : '增加客户'"
		:width="700"
		:visible="visible"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-row :gutter="16">
				<a-col :span="24">
					<a-form-item label="名称：" name="name">
						<a-input v-model:value="formData.name" placeholder="请输入名称" allow-clear />
					</a-form-item>
				</a-col>
				<a-col :span="24">
					<a-form-item label="编码：" name="number">
						<a-input v-model:value="formData.number" placeholder="请输入编码" allow-clear />
					</a-form-item>
				</a-col>
				<a-col :span="24">
					<a-form-item label="上级：" name="parentId">
						<a-tree-select
							v-model:value="formData.parentId"
							style="width: 100%"
							:dropdown-style="{ maxHeight: '400px', overflow: 'auto' }"
							:tree-data="parentTreeData"
							placeholder="请选择上级仓库"
							:fieldNames="{
								children: 'children',
								label: 'name',
								value: 'id'
							}"
						>
						</a-tree-select>
					</a-form-item>
				</a-col>
				<a-col :span="24">
					<a-form-item label="排序码：" name="sortCode">
						<a-input v-model:value="formData.sortCode" placeholder="请输入排序码" allow-clear />
					</a-form-item>
				</a-col>
			</a-row>
		</a-form>

		<OperationalInformation v-if="route.query.id" :detailData="formData" :colSpan="12"></OperationalInformation>

		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="customerForm">
	import tool from '@/utils/tool'
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import customerCategoryApi from '@/api/base/customer/customerCategoryApi'
	import { useRoute } from 'vue-router'
	const route = useRoute()

	// 抽屉状态
	const visible = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({
		sortCode: '99'
	})
	const submitLoading = ref(false)
	const enabledStateOptions = ref([])

	// 打开抽屉
	const onOpen = (record) => {
		visible.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
		enabledStateOptions.value = tool.dictList('COMMON_STATUS')

		customerCategoryApi.customerCategoryTree().then((res) => {
			parentTreeData.value = [
				{
					id: 0,
					parentId: '0',
					name: '顶级',
					children: res ? res : []
				}
			]
		})
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		visible.value = false
	}
	// 默认要校验的
	const formRules = {
		name: [required('请输入名称')],
		parentId: [required('请选择上级')]
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value.validate().then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			customerCategoryApi
				.customerCategorySubmitForm(formDataParam, formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
	}

	let parentTreeData = ref([])
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
